"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/plugins/nuxt3.ts
var nuxt3_exports = {};
__export(nuxt3_exports, {
  default: () => nuxt3_default
});
module.exports = __toCommonJS(nuxt3_exports);
var import_promises = require("fs/promises");
var import_node_path = require("path");
var import_kit = require("@nuxt/kit");

// src/plugins/core/index.ts
var import_child_process = __toESM(require("child_process"), 1);
var execCommand = (command) => {
  const { exec } = import_child_process.default;
  return new Promise((resolve2, reject) => {
    exec(command, (error, stdout) => {
      if (error) {
        reject(error);
      } else {
        const output = stdout.toString()?.replace("\n", "");
        resolve2(output);
      }
    });
  });
};
var analyticOptions = async (options) => {
  const {
    name = process.env["npm_package_name"],
    version = process.env["npm_package_version"],
    command = void 0,
    ifShortSHA = false,
    ifGitSHA = false,
    ifMeta = true,
    ifLog = true,
    ifGlobal = true,
    ifExport = false,
    outputFile
  } = options;
  const finalCommand = command ?? (ifShortSHA ? "git rev-parse --short HEAD" : ifGitSHA ? "git rev-parse HEAD" : void 0);
  const printVersion = finalCommand ? await execCommand(finalCommand) : version;
  const printName = `${name?.replace(/((?!\w).)/g, "_")?.toLocaleUpperCase?.()}_VERSION`;
  const printInfo = `${printName}: ${printVersion}`;
  const fileList = (() => {
    switch (typeof outputFile) {
      case "function": {
        const res = outputFile(printVersion);
        return Array.isArray(res) ? res : [res];
      }
      case "boolean":
        return outputFile ? [{ path: ".well-known/version", content: printVersion }] : [];
      default:
        return [];
    }
  })();
  return {
    ifMeta,
    ifLog,
    ifGlobal,
    ifExport,
    fileList,
    printVersion,
    printName,
    printInfo
  };
};

// src/plugins/nuxt3.ts
var nuxt3Module = (0, import_kit.defineNuxtModule)({
  meta: {
    name: "nuxt-version-mark"
  },
  // https://github.com/nuxt/bridge/blob/main/packages/bridge/src/module.ts
  async setup(options, nuxt) {
    const {
      fileList,
      ifMeta,
      ifLog,
      ifGlobal,
      printVersion,
      printName,
      printInfo
    } = await analyticOptions(options);
    nuxt.options.app.head.meta = nuxt.options.app.head.meta || [];
    nuxt.options.app.head.script = nuxt.options.app.head.script || [];
    nuxt.options.vite.define = nuxt.options.vite.define || {};
    if (ifMeta) {
      nuxt.options.app.head.meta.push({
        name: "application-name",
        content: printInfo
      });
    }
    if (ifLog) {
      nuxt.options.app.head.script.push({
        children: `console.log("${printInfo}")`
      });
    }
    if (ifGlobal) {
      nuxt.options.vite.define[`__${printName}__`] = JSON.stringify(printVersion);
      nuxt.options.app.head.script.push({
        children: `__${printName}__ = "${printVersion}"`
      });
    }
    if (fileList.length > 0) {
      nuxt.hook("nitro:build:public-assets", async ({ options: { output: { publicDir } } }) => {
        await Promise.all(fileList.map(async ({ path, content = "" }) => {
          const dir = (0, import_node_path.dirname)(path);
          const fullDir = (0, import_node_path.resolve)(publicDir, dir);
          const outputFilePath = (0, import_node_path.resolve)(publicDir, path);
          try {
            await (0, import_promises.mkdir)(fullDir, { recursive: true });
            await (0, import_promises.writeFile)(outputFilePath, content);
            console.info(`Generated version file in ${outputFilePath}`);
          } catch (error) {
            console.error(`Failed to generate file at ${outputFilePath}:`, error);
            throw error;
          }
        }));
      });
    }
  }
});
var nuxt3_default = nuxt3Module;
//# sourceMappingURL=index.cjs.map