import { NuxtModule } from '@nuxt/schema';

interface OutputFile {
    path: string;
    content: string;
}
type OutputFileFunction = (version: string) => OutputFile | OutputFile[];
interface VitePluginVersionMarkBaseInput {
    name?: string;
    version?: string;
    ifMeta?: boolean;
    ifLog?: boolean;
    ifGlobal?: boolean;
    ifExport?: boolean;
    outputFile?: boolean | OutputFileFunction;
}
interface VitePluginVersionMarkGitInput extends VitePluginVersionMarkBaseInput {
    ifGitSHA?: boolean;
    ifShortSHA?: boolean;
}
interface VitePluginVersionMarkCommandInput extends VitePluginVersionMarkBaseInput {
    command?: string;
}
type VitePluginVersionMarkInput = VitePluginVersionMarkGitInput & VitePluginVersionMarkCommandInput;

type ModuleOptions = VitePluginVersionMarkInput;
declare const nuxt3Module: NuxtModule<ModuleOptions>;

export { type ModuleOptions, nuxt3Module as default };
