import { Plugin } from 'vite';

interface OutputFile {
    path: string;
    content: string;
}
type OutputFileFunction = (version: string) => OutputFile | OutputFile[];
interface VitePluginVersionMarkBaseInput {
    name?: string;
    version?: string;
    ifMeta?: boolean;
    ifLog?: boolean;
    ifGlobal?: boolean;
    ifExport?: boolean;
    outputFile?: boolean | OutputFileFunction;
}
interface VitePluginVersionMarkGitInput extends VitePluginVersionMarkBaseInput {
    ifGitSHA?: boolean;
    ifShortSHA?: boolean;
}
interface VitePluginVersionMarkCommandInput extends VitePluginVersionMarkBaseInput {
    command?: string;
}
type VitePluginVersionMarkInput = VitePluginVersionMarkGitInput & VitePluginVersionMarkCommandInput;

declare const vitePluginVersionMark: (options?: VitePluginVersionMarkInput) => Plugin;

export { type VitePluginVersionMarkInput, vitePluginVersionMark };
